; ========================================================================== ;
;                            .: Stack 'Em! :.                                ;
;             4K Intellivision game for the MiniGame Compo 2004              ;
; -------------------------------------------------------------------------- ;
;                      Mail : a_chevallier@yahoo.com                         ;
;                       Web : http://intyos.free.fr                          ;
; ========================================================================== ;
;  This program is free software; you can redistribute it and/or modify      ;
;  it under the terms of the GNU General Public License as published by      ;
;  the Free Software Foundation; either version 2 of the License, or         ;
;  (at your option) any later version.                                       ;
;                                                                            ;
;  This program is distributed in the hope that it will be useful,           ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of            ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU          ;
;  General Public License for more details.                                  ;
;                                                                            ;
;  You should have received a copy of the GNU General Public License         ;
;  along with this program; if not, write to the Free Software               ;
;  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 ;
; ========================================================================== ;
;                   Copyright (c) 2004, Arnauld Chevallier                   ;
; ========================================================================== ;


; ========================================================================== ;
; Common song data                                                           ;
; ========================================================================== ;

; -------------------------------------------------------------------------- ;
; Macros                                                                     ;
; -------------------------------------------------------------------------- ;

            INCLUDE     "tracker.mac"

; -------------------------------------------------------------------------- ;
; Envelopes                                                                  ;
; -------------------------------------------------------------------------- ;

env01:      ; envelope #1
            DECLE       1
            DECLE       $FEDC, $BA87, $6531, $0000, $0000, $0000, $0000, $0000
            DECLE       $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000

; -------------------------------------------------------------------------- ;
; Pitches                                                                    ;
; -------------------------------------------------------------------------- ;

pitch01:    DECLE       0, 0, 0, 0

; -------------------------------------------------------------------------- ;
; Drums                                                                      ;
; -------------------------------------------------------------------------- ;

            ; drum #1
drum1:      Drum($380, $10, 0, 1, $F)
            Drum($380, $10, 1, 0, $F)
            Drum($380, $10, 1, 0, $F)
            Drum($580, $1F, 1, 0, $E)
            Drum($580, $1F, 1, 1, $D)
            Drum($580, $1F, 1, 1, $C)
            Drum($580, $1F, 1, 0, $A)
            Drum($580, $1F, 1, 0, $8)

            ; drum #2
drum2:      Drum($280, $10, 0, 1, $F)
            Drum($280, $10, 1, 0, $F)
            Drum($280, $10, 1, 0, $F)
            Drum($480, $1F, 1, 0, $E)
            Drum($480, $1F, 1, 1, $D)
            Drum($480, $1F, 1, 1, $C)
            Drum($480, $1F, 1, 0, $A)
            Drum($480, $1F, 1, 0, $8)

            ; hit-hat
hithat:     Drum($380, $04, 0, 1, $D)
            Drum($380, $04, 0, 1, $6)
            Drum(0, 0, 0, 0, 0)
            Drum(0, 0, 0, 0, 0)
            Drum(0, 0, 0, 0, 0)
            Drum(0, 0, 0, 0, 0)
            Drum(0, 0, 0, 0, 0)
            Drum(0, 0, 0, 0, 0)

; ========================================================================== ;
; Song #00 - Columns                                                         ;
; ========================================================================== ;

song00      PROC

; -------------------------------------------------------------------------- ;
; Header                                                                     ;
; -------------------------------------------------------------------------- ;

            ; speed / pointers
            DECLE       6, @@patterns, @@instr

            ; order of patterns
            DECLE       0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, -8 AND $FFFF

; -------------------------------------------------------------------------- ;
; Detail of patterns                                                         ;
; -------------------------------------------------------------------------- ;

@@patterns: DECLE       32, @@p000, @@p001, @@p000    ; 0
            DECLE       32, @@p000, @@p002, @@p000    ; 1
            DECLE       32, @@p000, @@p001, @@p003    ; 2
            DECLE       32, @@p000, @@p002, @@p004    ; 3
            DECLE       32, @@p005, @@p001, @@p006    ; 4
            DECLE       32, @@p007, @@p002, @@p008    ; 5
            DECLE       32, @@p005, @@p001, @@p003    ; 6
            DECLE       32, @@p007, @@p002, @@p004    ; 7
            DECLE       32, @@p005, @@p001, @@p009    ; 8
            DECLE       32, @@p007, @@p002, @@p004    ; 9
            DECLE       32, @@p005, @@p001, @@p010    ; 10
            DECLE       32, @@p007, @@p002, @@p011    ; 11

; -------------------------------------------------------------------------- ;
; Instruments                                                                ;
; -------------------------------------------------------------------------- ;

@@instr:    ; standard instruments
            DECLE       pitch01, 1, env01
            DECLE       pitch01, 1, env01
            DECLE       pitch01, 1, env01
            DECLE       pitch01, 1, env01

            ; drums
            DECLE       drum1
            DECLE       drum2
            DECLE       hithat

; -------------------------------------------------------------------------- ;
; Patterns                                                                   ;
; -------------------------------------------------------------------------- ;

            ; pattern #0 / channel A
@@p000:     Notes("NUL 00F", "NUL 00F", "", "")

            ; pattern #0 / channel B
@@p001:     Notes("G-4 0F3", "F-4 0F1", "D#4 0F1", "D-4 0F1")
            Notes("C-4 0F1", "D-4 0F1", "D#4 0F1", "D-4 0F3")
            Notes("A#3 0F1", "A-3 0F1", "A#3 0F3", "G-3 0F3")

            ; pattern #1 / channel B
@@p002:     Notes("G#3 0F1", "C-4 0F1", "D#4 0F3", "F-4 0F3")
            Notes("D#4 0F1", "D-4 0F1", "G-3 0F1", "A#3 0F1")
            Notes("D#4 0F3", "G-3 0F1", "A#3 0F1", "D#4 0F3")

            ; pattern #2 / channel C
@@p003:     Notes("C-5 0F7", "G-5 0F7", "G-4 0F7", "D-5 0F7")

            ; pattern #3 / channel C
@@p004:     Notes("D#5 0F1", "D-5 0F1", "D#5 0F1", "C-5 0F1")
            Notes("D#5 0F1", "D-5 0F1", "D#5 0F1", "C-5 0F1")
            Notes("G-4 0F1", "F-4 0F1", "G-4 0F1", "D#4 0F1")
            Notes("D#4 0F1", "F-4 0F1", "G-4 0F1", "A#4 0F1")

            ; pattern #4 / channel A
@@p005:     Notes("DRM 1F1", "C-3 0F1", "DRM 3F1", "C-3 0F1")
            Notes("DRM 2F1", "C-3 0F1", "DRM 3F1", "C-3 0F1")
            Notes("DRM 1F1", "G-2 0F1", "DRM 3F1", "G-2 0F1")
            Notes("DRM 2F1", "G-2 0F1", "DRM 3F1", "G-2 0F1")

            ; pattern #4 / channel C
@@p006:     Notes("C-5 0FF", "G-4 0FF", "", "")

            ; pattern #5 / channel A
@@p007:     Notes("DRM 1F1", "G#2 0F1", "DRM 3F1", "G#2 0F1")
            Notes("DRM 2F1", "G#2 0F1", "DRM 3F1", "G#2 0F1")
            Notes("DRM 1F1", "D#2 0F1", "DRM 3F1", "D#2 0F1")
            Notes("DRM 2F1", "D#2 0F1", "DRM 3F1", "D#2 0F1")

            ; pattern #5 / channel C
@@p008:     Notes("G#4 0FF", "G-4 0FF", "", "")

            ; pattern #8 / channel C
@@p009:     Notes("C-5 0F3", "A#4 0F1", "C-5 0F1", "D#5 0F3")
            Notes("D-5 0F1", "F-5 0F1", "G-5 0F3", "D-5 0F1")
            Notes("C-5 0F1", "D-5 0F3", "A#4 0F3", "")

            ; pattern #10 / channel C
@@p010:     Notes("C-5 0F3", "D-5 0F3", "D#5 0F3", "C-5 0F1")
            Notes("F-5 0F1", "G-5 0FF", "", "")

            ; pattern #11 / channel C
@@p011:     Notes("G#4 0F3", "C-5 0F3", "D#5 0F3", "D-5 0F1")
            Notes("C-5 0F1", "G-4 0FF", "", "")

            ENDP

; ========================================================================== ;
; Song #01 - Columns                                                         ;
; ========================================================================== ;

song01      PROC

; -------------------------------------------------------------------------- ;
; Header                                                                     ;
; -------------------------------------------------------------------------- ;

            ; speed / pointers
            DECLE       7, @@patterns, @@instr

            ; order of patterns
            DECLE       0, 3 AND $FFFF

; -------------------------------------------------------------------------- ;
; Detail of patterns                                                         ;
; -------------------------------------------------------------------------- ;

@@patterns: DECLE       64, @@p000, @@p001, @@p002    ; 0

; -------------------------------------------------------------------------- ;
; Instruments                                                                ;
; -------------------------------------------------------------------------- ;

@@instr:    ; standard instruments
            DECLE       pitch01, 3, env01

; -------------------------------------------------------------------------- ;
; Patterns                                                                   ;
; -------------------------------------------------------------------------- ;

            ; pattern #0 / channel A
@@p000:     Notes("B-4 0C1", "A#4 0D1", "F#4 0E1", "G#4 0FF")
            Notes("NUL 00F", "NUL 00F", "NUL 009", "")

            ; pattern #0 / channel B
@@p001:     Notes("C#4 0C1", "D#4 0D1", "F#4 0E1", "G#3 0FF")
            Notes("NUL 00F", "NUL 00F", "NUL 009", "")

            ; pattern #0 / channel C
@@p002:     Notes("B-3 0C1", "D#4 0D1", "B-3 0E1", "D#4 0FF")
            Notes("NUL 00F", "NUL 00F", "NUL 009", "")

            ENDP
